//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern string TimeFrames        = "M1;M5;M15;M30";
extern string TimeFramesWeights = "1;1;1;1";
extern string TimeFramesLengths = "15;15;15;15";
extern int    Price             = PRICE_CLOSE;
extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = true;
extern double alertsLevel       = 5;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;


//
//
//
//
//

double valuesBuffer[];
double trendsBuffer[];
double weights[];
int    timeFrames[];
int    lengths[];

//
//
//
//
//

int    totalTimeFrames;
int    minimalTimeFrame;
string indicatorFileName;
bool   calculatingValue;
bool   returnBars;
int    Length;

//+-------------------------------------------------------------------
//|                                                                  |  
//+-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,valuesBuffer);
   SetIndexBuffer(1,trendsBuffer);
      indicatorFileName = WindowExpertName();
      calculatingValue  = (TimeFrames=="calculateValue"); if (calculatingValue) { Length = StrToInteger(TimeFramesLengths); return(0); }
      returnBars        = (TimeFrames=="returnBars");     if (returnBars)       return(0);
   
   //
   //
   //
   //
   //
   
         TimeFrames = StringTrimLeft(StringTrimRight(TimeFrames));
         if (StringSubstr(TimeFrames,StringLen(TimeFrames),1) != ";")
                          TimeFrames = StringConcatenate(TimeFrames,";");

         //
         //
         //
         //
         //                                   
            
            int s = 0;
            int i = StringFind(TimeFrames,";",s);

                  while (i > 0)
                  {
                     string current = StringSubstr(TimeFrames,s,i-s);
                     int time       = stringToTimeFrame(current);
                     if (time > 0) {
                           ArrayResize(timeFrames,ArraySize(timeFrames)+1);
                                       timeFrames[ArraySize(timeFrames)-1] = time; }                                 
                                       s = i + 1;
                                           i = StringFind(TimeFrames,";",s);
                  }               
                  
            totalTimeFrames = ArraySize(timeFrames);
            minimalTimeFrame = PERIOD_MN1;
               
               //
               //
               //
               //
               //
               
               for (i=0; i<totalTimeFrames; i++)            
                     minimalTimeFrame = MathMin(minimalTimeFrame,timeFrames[i]);
                     
         
         //
         //
         //
         //
         //
            
         TimeFramesWeights = StringTrimLeft(StringTrimRight(TimeFramesWeights));
         if (StringSubstr(TimeFramesWeights,StringLen(TimeFramesWeights),1) != ";")
                          TimeFramesWeights = StringConcatenate(TimeFramesWeights,";");
                                 ArrayResize(weights,totalTimeFrames);
                                 ArrayInitialize(weights,1);
            //
            //
            //
            //
            //
            
            int k = 0;             
                s = 0;
                i = StringFind(TimeFramesWeights,";",s);
                while (i > 0)
                {
                  string currenw    = StringSubstr(TimeFramesWeights,s,i-s);
                         weights[k] = StrToDouble(currenw);
                                  s = i + 1;
                                  k = k + 1;
                                  i = StringFind(TimeFramesWeights,";",s);
            }
            
         //
         //
         //
         //
         //
            
         TimeFramesLengths = StringTrimLeft(StringTrimRight(TimeFramesLengths));
         if (StringSubstr(TimeFramesLengths,StringLen(TimeFramesLengths),1) != ";")
                          TimeFramesLengths = StringConcatenate(TimeFramesLengths,";");
                                 ArrayResize(lengths,totalTimeFrames);
                                 ArrayInitialize(lengths,0);
            //
            //
            //
            //
            //
            
                k = 0;             
                s = 0;
                i = StringFind(TimeFramesLengths,";",s);
                while (i > 0)
                {
                  string currenl    = StringSubstr(TimeFramesLengths,s,i-s);
                         lengths[k] = StrToDouble(currenl);
                                  s = i + 1;
                                  k = k + 1;
                                  i = StringFind(TimeFramesLengths,";",s);
            }
            
         
   //
   //
   //
   //
   //
   
   SetLevelValue(0, 0);
   SetLevelValue(1, alertsLevel);
   SetLevelValue(2,-alertsLevel);
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  |
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { valuesBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

      if (calculatingValue)
      {  
         for (i=limit; i>=0; i--)
         {
            valuesBuffer[i] = iNoLagMa(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,0,i);
            trendsBuffer[i] = trendsBuffer[i+1];
               if (valuesBuffer[i]>valuesBuffer[i+1]) trendsBuffer[i]= 1;
               if (valuesBuffer[i]<valuesBuffer[i+1]) trendsBuffer[i]=-1;
         }            
         return(0);
      }
   
   //
   //
   //
   //
   //

      if (Period()>minimalTimeFrame)
      {
            Comment("you should use this indicator on "+timeFrameToString(minimalTimeFrame)+" period");
            return(0);
      }     
      
      //
      //
      //
      //
      //
      
      for (int k=0; k<totalTimeFrames; k++) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[k],indicatorFileName,"returnBars",0,0)*timeFrames[k]/Period()));
      for (i=limit; i>=0; i--)
      {
         valuesBuffer[i]=0;
         
         //
         //
         //
         //
         //
         
            for (k=0; k<totalTimeFrames; k++)
            {
               int y = iBarShift(NULL,timeFrames[k],Time[i]);
               if (lengths[k]>0)
                     valuesBuffer[i] += weights[k]*iCustom(NULL,timeFrames[k],indicatorFileName,"calculateValue","",DoubleToStr(lengths[k],0),Price,1,y);
            }

         //
         //
         //
         //
         //
         
         trendsBuffer[i] = 0;
         if (MathAbs(valuesBuffer[i])>=alertsLevel)
            if (valuesBuffer[i]>0) trendsBuffer[i] =  1;
            else                   trendsBuffer[i] = -1;
      }

   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);	
}

//+-------------------------------------------------------------------
//|                                                                   |
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trendsBuffer[whichBar] ==  1) doAlert(whichBar,"up"  ,valuesBuffer[whichBar]);
      if (trendsBuffer[whichBar] == -1) doAlert(whichBar,"down",valuesBuffer[whichBar]);
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," NonLagMAs alligned to value "+DoubleToStr(value,2)+" trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"NonLagMAs "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+------------------------------------------------------------------
//|                                                                  |
//+------------------------------------------------------------------
//
//
//
//
//

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

#define numOfSeparateCalculations 1
double  nlm.values[3][numOfSeparateCalculations];
double  nlm.prices[ ][numOfSeparateCalculations];
double  nlm.alphas[ ][numOfSeparateCalculations];

//
//
//
//
//

double iNoLagMa(double price, int length, int forValue, int i)
{
   if (ArrayRange(nlm.prices,0) != Bars) ArrayResize(nlm.prices,Bars);
            int r = Bars-i-1;  nlm.prices[r][forValue]=price;
   if (length<3 || r<3) return(nlm.prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_length][forValue] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
         nlm.values[_length][forValue] = length;
         nlm.values[_len   ][forValue] = length*4 + Phase;  
         nlm.values[_weight][forValue] = 0;

         if (ArrayRange(nlm.alphas,0) < nlm.values[_len][forValue]) ArrayResize(nlm.alphas,nlm.values[_len][forValue]);
         for (int k=0; k<nlm.values[_len][forValue]; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlm.alphas[k][forValue]        = g * beta;
            nlm.values[_weight][forValue] += nlm.alphas[k][forValue];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (nlm.values[_weight][forValue]>0)
   {
      double sum = 0;
           for (k=0; k < nlm.values[_len][forValue]; k++) sum += nlm.alphas[k][forValue]*nlm.prices[r-k][forValue];
           return( sum / nlm.values[_weight][forValue]);
   }
   else return(0);           
}

//+-------------------------------------------------------------------
//|                                                                   |
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
//========================================================================+